#ifndef BITS_SYSCALL_H
#define BITS_SYSCALL_H

#define NR_exit                       1
#define NR_fork                       2
#define NR_read                       3
#define NR_write                      4
#define NR_open                       5
#define NR_close                      6
#define NR_creat                      8
#define NR_link                       9
#define NR_unlink                     10
#define NR_execve                     11
#define NR_chdir                      12
#define NR_time                       13
#define NR_mknod                      14
#define NR_chmod                      15
#define NR_lchown                     16
#define NR_lseek                      19
#define NR_getpid                     20
#define NR_mount                      21
#define NR_umount                     22
#define NR_setuid                     23
#define NR_getuid                     24
#define NR_stime                      25
#define NR_ptrace                     26
#define NR_alarm                      27
#define NR_pause                      29
#define NR_utime                      30
#define NR_access                     33
#define NR_nice                       34
#define NR_sync                       36
#define NR_kill                       37
#define NR_rename                     38
#define NR_mkdir                      39
#define NR_rmdir                      40
#define NR_dup                        41
#define NR_pipe                       42
#define NR_times                      43
#define NR_brk                        45
#define NR_setgid                     46
#define NR_getgid                     47
#define NR_geteuid                    49
#define NR_getegid                    50
#define NR_acct                       51
#define NR_umount2                    52
#define NR_ioctl                      54
#define NR_fcntl                      55
#define NR_setpgid                    57
#define NR_umask                      60
#define NR_chroot                     61
#define NR_ustat                      62
#define NR_dup2                       63
#define NR_getppid                    64
#define NR_getpgrp                    65
#define NR_setsid                     66
#define NR_sigaction                  67
#define NR_setreuid                   70
#define NR_setregid                   71
#define NR_sigsuspend                 72
#define NR_sigpending                 73
#define NR_sethostname                74
#define NR_setrlimit                  75
#define NR_getrlimit                  76
#define NR_getrusage                  77
#define NR_gettimeofday               78
#define NR_settimeofday               79
#define NR_getgroups                  80
#define NR_setgroups                  81
#define NR_select                     82
#define NR_symlink                    83
#define NR_readlink                   85
#define NR_uselib                     86
#define NR_swapon                     87
#define NR_reboot                     88
#define NR_readdir                    89
#define NR_mmap                       90
#define NR_munmap                     91
#define NR_truncate                   92
#define NR_ftruncate                  93
#define NR_fchmod                     94
#define NR_fchown                     95
#define NR_getpriority                96
#define NR_setpriority                97
#define NR_statfs                     99
#define NR_fstatfs                    100
#define NR_socketcall                 102
#define NR_syslog                     103
#define NR_setitimer                  104
#define NR_getitimer                  105
#define NR_stat                       106
#define NR_lstat                      107
#define NR_fstat                      108
#define NR_vhangup                    111
#define NR_syscall                    113
#define NR_wait4                      114
#define NR_swapoff                    115
#define NR_sysinfo                    116
#define NR_ipc                        117
#define NR_fsync                      118
#define NR_sigreturn                  119
#define NR_clone                      120
#define NR_setdomainname              121
#define NR_uname                      122
#define NR_adjtimex                   124
#define NR_mprotect                   125
#define NR_sigprocmask                126
#define NR_init_module                128
#define NR_delete_module              129
#define NR_quotactl                   131
#define NR_getpgid                    132
#define NR_fchdir                     133
#define NR_bdflush                    134
#define NR_sysfs                      135
#define NR_personality                136
#define NR_setfsuid                   138
#define NR_setfsgid                   139
#define NR__llseek                    140
#define NR_getdents                   141
#define NR__newselect                 142
#define NR_flock                      143
#define NR_msync                      144
#define NR_readv                      145
#define NR_writev                     146
#define NR_getsid                     147
#define NR_fdatasync                  148
#define NR__sysctl                    149
#define NR_mlock                      150
#define NR_munlock                    151
#define NR_mlockall                   152
#define NR_munlockall                 153
#define NR_sched_setparam             154
#define NR_sched_getparam             155
#define NR_sched_setscheduler         156
#define NR_sched_getscheduler         157
#define NR_sched_yield                158
#define NR_sched_get_priority_max     159
#define NR_sched_get_priority_min     160
#define NR_sched_rr_get_interval      161
#define NR_nanosleep                  162
#define NR_mremap                     163
#define NR_setresuid                  164
#define NR_getresuid                  165
#define NR_poll                       168
#define NR_nfsservctl                 169
#define NR_setresgid                  170
#define NR_getresgid                  171
#define NR_prctl                      172
#define NR_rt_sigreturn               173
#define NR_rt_sigaction               174
#define NR_rt_sigprocmask             175
#define NR_rt_sigpending              176
#define NR_rt_sigtimedwait            177
#define NR_rt_sigqueueinfo            178
#define NR_rt_sigsuspend              179
#define NR_pread64                    180
#define NR_pwrite64                   181
#define NR_chown                      182
#define NR_getcwd                     183
#define NR_capget                     184
#define NR_capset                     185
#define NR_sigaltstack                186
#define NR_sendfile                   187
#define NR_vfork                      190
#define NR_ugetrlimit                 191
#define NR_mmap2                      192
#define NR_truncate64                 193
#define NR_ftruncate64                194
#define NR_stat64                     195
#define NR_lstat64                    196
#define NR_fstat64                    197
#define NR_lchown32                   198
#define NR_getuid32                   199
#define NR_getgid32                   200
#define NR_geteuid32                  201
#define NR_getegid32                  202
#define NR_setreuid32                 203
#define NR_setregid32                 204
#define NR_getgroups32                205
#define NR_setgroups32                206
#define NR_fchown32                   207
#define NR_setresuid32                208
#define NR_getresuid32                209
#define NR_setresgid32                210
#define NR_getresgid32                211
#define NR_chown32                    212
#define NR_setuid32                   213
#define NR_setgid32                   214
#define NR_setfsuid32                 215
#define NR_setfsgid32                 216
#define NR_getdents64                 217
#define NR_pivot_root                 218
#define NR_mincore                    219
#define NR_madvise                    220
#define NR_fcntl64                    221
#define NR_gettid                     224
#define NR_readahead                  225
#define NR_setxattr                   226
#define NR_lsetxattr                  227
#define NR_fsetxattr                  228
#define NR_getxattr                   229
#define NR_lgetxattr                  230
#define NR_fgetxattr                  231
#define NR_listxattr                  232
#define NR_llistxattr                 233
#define NR_flistxattr                 234
#define NR_removexattr                235
#define NR_lremovexattr               236
#define NR_fremovexattr               237
#define NR_tkill                      238
#define NR_sendfile64                 239
#define NR_futex                      240
#define NR_sched_setaffinity          241
#define NR_sched_getaffinity          242
#define NR_io_setup                   243
#define NR_io_destroy                 244
#define NR_io_getevents               245
#define NR_io_submit                  246
#define NR_io_cancel                  247
#define NR_exit_group                 248
#define NR_lookup_dcookie             249
#define NR_epoll_create               250
#define NR_epoll_ctl                  251
#define NR_epoll_wait                 252
#define NR_remap_file_pages           253
#define NR_set_tid_address            256
#define NR_timer_create               257
#define NR_timer_settime              258
#define NR_timer_gettime              259
#define NR_timer_getoverrun           260
#define NR_timer_delete               261
#define NR_clock_settime              262
#define NR_clock_gettime              263
#define NR_clock_getres               264
#define NR_clock_nanosleep            265
#define NR_statfs64                   266
#define NR_fstatfs64                  267
#define NR_tgkill                     268
#define NR_utimes                     269
#define NR_arm_fadvise64_64           270
#define NR_pciconfig_iobase           271
#define NR_pciconfig_read             272
#define NR_pciconfig_write            273
#define NR_mq_open                    274
#define NR_mq_unlink                  275
#define NR_mq_timedsend               276
#define NR_mq_timedreceive            277
#define NR_mq_notify                  278
#define NR_mq_getsetattr              279
#define NR_waitid                     280
#define NR_socket                     281
#define NR_bind                       282
#define NR_connect                    283
#define NR_listen                     284
#define NR_accept                     285
#define NR_getsockname                286
#define NR_getpeername                287
#define NR_socketpair                 288
#define NR_send                       289
#define NR_sendto                     290
#define NR_recv                       291
#define NR_recvfrom                   292
#define NR_shutdown                   293
#define NR_setsockopt                 294
#define NR_getsockopt                 295
#define NR_sendmsg                    296
#define NR_recvmsg                    297
#define NR_semop                      298
#define NR_semget                     299
#define NR_semctl                     300
#define NR_msgsnd                     301
#define NR_msgrcv                     302
#define NR_msgget                     303
#define NR_msgctl                     304
#define NR_shmat                      305
#define NR_shmdt                      306
#define NR_shmget                     307
#define NR_shmctl                     308
#define NR_add_key                    309
#define NR_request_key                310
#define NR_keyctl                     311
#define NR_semtimedop                 312
#define NR_vserver                    313
#define NR_ioprio_set                 314
#define NR_ioprio_get                 315
#define NR_inotify_init               316
#define NR_inotify_add_watch          317
#define NR_inotify_rm_watch           318
#define NR_mbind                      319
#define NR_get_mempolicy              320
#define NR_set_mempolicy              321
#define NR_openat                     322
#define NR_mkdirat                    323
#define NR_mknodat                    324
#define NR_fchownat                   325
#define NR_futimesat                  326
#define NR_fstatat64                  327
#define NR_unlinkat                   328
#define NR_renameat                   329
#define NR_linkat                     330
#define NR_symlinkat                  331
#define NR_readlinkat                 332
#define NR_fchmodat                   333
#define NR_faccessat                  334
#define NR_ppoll                      336
#define NR_unshare                    337
#define NR_set_robust_list            338
#define NR_get_robust_list            339
#define NR_splice                     340
#define NR_arm_sync_file_range        341
#define NR_tee                        342
#define NR_vmsplice                   343
#define NR_move_pages                 344
#define NR_getcpu                     345
#define NR_kexec_load                 347
#define NR_utimensat                  348
#define NR_signalfd                   349
#define NR_timerfd                    350
#define NR_eventfd                    351
#define NR_fallocate                  352
#define NR_timerfd_settime            353
#define NR_timerfd_gettime            354
#define NR_signalfd4                  355
#define NR_eventfd2                   356
#define NR_epoll_create1              357
#define NR_dup3                       358
#define NR_pipe2                      359
#define NR_inotify_init1              360
#define NR_preadv                     361
#define NR_pwritev                    362
#define NR_rt_tgsigqueueinfo          363
#define NR_perf_event_open            364
#define NR_recvmmsg                   365
#define NR_accept4                    366
#define NR_fanotify_init              367
#define NR_fanotify_mark              368
#define NR_prlimit64                  369
#define NR_name_to_handle_at          370
#define NR_open_by_handle_at          371
#define NR_clock_adjtime              372
#define NR_syncfs                     373
#define NR_sendmmsg                   374
#define NR_setns                      375
#define NR_process_vm_readv           376
#define NR_process_vm_writev          377
#define NR_kcmp                       378
#define NR_finit_module               379
#define NR_sched_setattr              380
#define NR_sched_getattr              381
#define NR_renameat2                  382
#define NR_seccomp                    383
#define NR_getrandom                  384
#define NR_memfd_create               385
#define NR_bpf                        386
#define NR_execveat                   387
#define NR_userfaultfd                388
#define NR_membarrier                 389
#define NR_mlock2                     390
#define NR_copy_file_range            391
#define NR_preadv2                    392
#define NR_pwritev2                   393

#endif
