#ifndef __BITS_SYSCALL_H__
#define __BITS_SYSCALL_H__

#define NR(n) (4000 + n) /* O32 syscalls */

#define NR_exit                       NR(1)
#define NR_fork                       NR(2)
#define NR_read                       NR(3)
#define NR_write                      NR(4)
#define NR_open                       NR(5)
#define NR_close                      NR(6)
#define NR_waitpid                    NR(7)
#define NR_creat                      NR(8)
#define NR_link                       NR(9)
#define NR_unlink                     NR(10)
#define NR_execve                     NR(11)
#define NR_chdir                      NR(12)
#define NR_time                       NR(13)
#define NR_mknod                      NR(14)
#define NR_chmod                      NR(15)
#define NR_lchown                     NR(16)
#define NR_break                      NR(17)
#define NR_unused18                   NR(18)
#define NR_lseek                      NR(19)
#define NR_getpid                     NR(20)
#define NR_mount                      NR(21)
#define NR_umount                     NR(22)
#define NR_setuid                     NR(23)
#define NR_getuid                     NR(24)
#define NR_stime                      NR(25)
#define NR_ptrace                     NR(26)
#define NR_alarm                      NR(27)
#define NR_unused28                   NR(28)
#define NR_pause                      NR(29)
#define NR_utime                      NR(30)
#define NR_stty                       NR(31)
#define NR_gtty                       NR(32)
#define NR_access                     NR(33)
#define NR_nice                       NR(34)
#define NR_ftime                      NR(35)
#define NR_sync                       NR(36)
#define NR_kill                       NR(37)
#define NR_rename                     NR(38)
#define NR_mkdir                      NR(39)
#define NR_rmdir                      NR(40)
#define NR_dup                        NR(41)
#define NR_pipe                       NR(42)
#define NR_times                      NR(43)
#define NR_prof                       NR(44)
#define NR_brk                        NR(45)
#define NR_setgid                     NR(46)
#define NR_getgid                     NR(47)
#define NR_signal                     NR(48)
#define NR_geteuid                    NR(49)
#define NR_getegid                    NR(50)
#define NR_acct                       NR(51)
#define NR_umount2                    NR(52)
#define NR_lock                       NR(53)
#define NR_ioctl                      NR(54)
#define NR_fcntl                      NR(55)
#define NR_mpx                        NR(56)
#define NR_setpgid                    NR(57)
#define NR_ulimit                     NR(58)
#define NR_unused59                   NR(59)
#define NR_umask                      NR(60)
#define NR_chroot                     NR(61)
#define NR_ustat                      NR(62)
#define NR_dup2                       NR(63)
#define NR_getppid                    NR(64)
#define NR_getpgrp                    NR(65)
#define NR_setsid                     NR(66)
#define NR_sigaction                  NR(67)
#define NR_sgetmask                   NR(68)
#define NR_ssetmask                   NR(69)
#define NR_setreuid                   NR(70)
#define NR_setregid                   NR(71)
#define NR_sigsuspend                 NR(72)
#define NR_sigpending                 NR(73)
#define NR_sethostname                NR(74)
#define NR_setrlimit                  NR(75)
#define NR_getrlimit                  NR(76)
#define NR_getrusage                  NR(77)
#define NR_gettimeofday               NR(78)
#define NR_settimeofday               NR(79)
#define NR_getgroups                  NR(80)
#define NR_setgroups                  NR(81)
#define NR_reserved82                 NR(82)
#define NR_symlink                    NR(83)
#define NR_unused84                   NR(84)
#define NR_readlink                   NR(85)
#define NR_uselib                     NR(86)
#define NR_swapon                     NR(87)
#define NR_reboot                     NR(88)
#define NR_readdir                    NR(89)
#define NR_mmap                       NR(90)
#define NR_munmap                     NR(91)
#define NR_truncate                   NR(92)
#define NR_ftruncate                  NR(93)
#define NR_fchmod                     NR(94)
#define NR_fchown                     NR(95)
#define NR_getpriority                NR(96)
#define NR_setpriority                NR(97)
#define NR_profil                     NR(98)
#define NR_statfs                     NR(99)
#define NR_fstatfs                    NR(100)
#define NR_ioperm                     NR(101)
#define NR_socketcall                 NR(102)
#define NR_syslog                     NR(103)
#define NR_setitimer                  NR(104)
#define NR_getitimer                  NR(105)
#define NR_stat                       NR(106)
#define NR_lstat                      NR(107)
#define NR_fstat                      NR(108)
#define NR_unused109                  NR(109)
#define NR_iopl                       NR(110)
#define NR_vhangup                    NR(111)
#define NR_idle                       NR(112)
#define NR_vm86                       NR(113)
#define NR_wait4                      NR(114)
#define NR_swapoff                    NR(115)
#define NR_sysinfo                    NR(116)
#define NR_ipc                        NR(117)
#define NR_fsync                      NR(118)
#define NR_sigreturn                  NR(119)
#define NR_clone                      NR(120)
#define NR_setdomainname              NR(121)
#define NR_uname                      NR(122)
#define NR_modify_ldt                 NR(123)
#define NR_adjtimex                   NR(124)
#define NR_mprotect                   NR(125)
#define NR_sigprocmask                NR(126)
#define NR_create_module              NR(127)
#define NR_init_module                NR(128)
#define NR_delete_module              NR(129)
#define NR_get_kernel_syms            NR(130)
#define NR_quotactl                   NR(131)
#define NR_getpgid                    NR(132)
#define NR_fchdir                     NR(133)
#define NR_bdflush                    NR(134)
#define NR_sysfs                      NR(135)
#define NR_personality                NR(136)
#define NR_afs_syscall                NR(137)
#define NR_setfsuid                   NR(138)
#define NR_setfsgid                   NR(139)
#define NR__llseek                    NR(140)
#define NR_getdents                   NR(141)
#define NR__newselect                 NR(142)
#define NR_flock                      NR(143)
#define NR_msync                      NR(144)
#define NR_readv                      NR(145)
#define NR_writev                     NR(146)
#define NR_cacheflush                 NR(147)
#define NR_cachectl                   NR(148)
#define NR_sysmips                    NR(149)
#define NR_unused150                  NR(150)
#define NR_getsid                     NR(151)
#define NR_fdatasync                  NR(152)
#define NR__sysctl                    NR(153)
#define NR_mlock                      NR(154)
#define NR_munlock                    NR(155)
#define NR_mlockall                   NR(156)
#define NR_munlockall                 NR(157)
#define NR_sched_setparam             NR(158)
#define NR_sched_getparam             NR(159)
#define NR_sched_setscheduler         NR(160)
#define NR_sched_getscheduler         NR(161)
#define NR_sched_yield                NR(162)
#define NR_sched_get_priority_max     NR(163)
#define NR_sched_get_priority_min     NR(164)
#define NR_sched_rr_get_interval      NR(165)
#define NR_nanosleep                  NR(166)
#define NR_mremap                     NR(167)
#define NR_accept                     NR(168)
#define NR_bind                       NR(169)
#define NR_connect                    NR(170)
#define NR_getpeername                NR(171)
#define NR_getsockname                NR(172)
#define NR_getsockopt                 NR(173)
#define NR_listen                     NR(174)
#define NR_recv                       NR(175)
#define NR_recvfrom                   NR(176)
#define NR_recvmsg                    NR(177)
#define NR_send                       NR(178)
#define NR_sendmsg                    NR(179)
#define NR_sendto                     NR(180)
#define NR_setsockopt                 NR(181)
#define NR_shutdown                   NR(182)
#define NR_socket                     NR(183)
#define NR_socketpair                 NR(184)
#define NR_setresuid                  NR(185)
#define NR_getresuid                  NR(186)
#define NR_query_module               NR(187)
#define NR_poll                       NR(188)
#define NR_nfsservctl                 NR(189)
#define NR_setresgid                  NR(190)
#define NR_getresgid                  NR(191)
#define NR_prctl                      NR(192)
#define NR_rt_sigreturn               NR(193)
#define NR_rt_sigaction               NR(194)
#define NR_rt_sigprocmask             NR(195)
#define NR_rt_sigpending              NR(196)
#define NR_rt_sigtimedwait            NR(197)
#define NR_rt_sigqueueinfo            NR(198)
#define NR_rt_sigsuspend              NR(199)
#define NR_pread64                    NR(200)
#define NR_pwrite64                   NR(201)
#define NR_chown                      NR(202)
#define NR_getcwd                     NR(203)
#define NR_capget                     NR(204)
#define NR_capset                     NR(205)
#define NR_sigaltstack                NR(206)
#define NR_sendfile                   NR(207)
#define NR_getpmsg                    NR(208)
#define NR_putpmsg                    NR(209)
#define NR_mmap2                      NR(210)
#define NR_truncate64                 NR(211)
#define NR_ftruncate64                NR(212)
#define NR_stat64                     NR(213)
#define NR_lstat64                    NR(214)
#define NR_fstat64                    NR(215)
#define NR_pivot_root                 NR(216)
#define NR_mincore                    NR(217)
#define NR_madvise                    NR(218)
#define NR_getdents64                 NR(219)
#define NR_fcntl64                    NR(220)
#define NR_reserved221                NR(221)
#define NR_gettid                     NR(222)
#define NR_readahead                  NR(223)
#define NR_setxattr                   NR(224)
#define NR_lsetxattr                  NR(225)
#define NR_fsetxattr                  NR(226)
#define NR_getxattr                   NR(227)
#define NR_lgetxattr                  NR(228)
#define NR_fgetxattr                  NR(229)
#define NR_listxattr                  NR(230)
#define NR_llistxattr                 NR(231)
#define NR_flistxattr                 NR(232)
#define NR_removexattr                NR(233)
#define NR_lremovexattr               NR(234)
#define NR_fremovexattr               NR(235)
#define NR_tkill                      NR(236)
#define NR_sendfile64                 NR(237)
#define NR_futex                      NR(238)
#define NR_sched_setaffinity          NR(239)
#define NR_sched_getaffinity          NR(240)
#define NR_io_setup                   NR(241)
#define NR_io_destroy                 NR(242)
#define NR_io_getevents               NR(243)
#define NR_io_submit                  NR(244)
#define NR_io_cancel                  NR(245)
#define NR_exit_group                 NR(246)
#define NR_lookup_dcookie             NR(247)
#define NR_epoll_create               NR(248)
#define NR_epoll_ctl                  NR(249)
#define NR_epoll_wait                 NR(250)
#define NR_remap_file_pages           NR(251)
#define NR_set_tid_address            NR(252)
#define NR_restart_syscall            NR(253)
#define NR_fadvise64                  NR(254)
#define NR_statfs64                   NR(255)
#define NR_fstatfs64                  NR(256)
#define NR_timer_create               NR(257)
#define NR_timer_settime              NR(258)
#define NR_timer_gettime              NR(259)
#define NR_timer_getoverrun           NR(260)
#define NR_timer_delete               NR(261)
#define NR_clock_settime              NR(262)
#define NR_clock_gettime              NR(263)
#define NR_clock_getres               NR(264)
#define NR_clock_nanosleep            NR(265)
#define NR_tgkill                     NR(266)
#define NR_utimes                     NR(267)
#define NR_mbind                      NR(268)
#define NR_get_mempolicy              NR(269)
#define NR_set_mempolicy              NR(270)
#define NR_mq_open                    NR(271)
#define NR_mq_unlink                  NR(272)
#define NR_mq_timedsend               NR(273)
#define NR_mq_timedreceive            NR(274)
#define NR_mq_notify                  NR(275)
#define NR_mq_getsetattr              NR(276)
#define NR_vserver                    NR(277)
#define NR_waitid                     NR(278)
#define NR_add_key                    NR(280)
#define NR_request_key                NR(281)
#define NR_keyctl                     NR(282)
#define NR_set_thread_area            NR(283)
#define NR_inotify_init               NR(284)
#define NR_inotify_add_watch          NR(285)
#define NR_inotify_rm_watch           NR(286)
#define NR_migrate_pages              NR(287)
#define NR_openat                     NR(288)
#define NR_mkdirat                    NR(289)
#define NR_mknodat                    NR(290)
#define NR_fchownat                   NR(291)
#define NR_futimesat                  NR(292)
#define NR_fstatat64                  NR(293)
#define NR_unlinkat                   NR(294)
#define NR_renameat                   NR(295)
#define NR_linkat                     NR(296)
#define NR_symlinkat                  NR(297)
#define NR_readlinkat                 NR(298)
#define NR_fchmodat                   NR(299)
#define NR_faccessat                  NR(300)
#define NR_pselect6                   NR(301)
#define NR_ppoll                      NR(302)
#define NR_unshare                    NR(303)
#define NR_splice                     NR(304)
#define NR_sync_file_range            NR(305)
#define NR_tee                        NR(306)
#define NR_vmsplice                   NR(307)
#define NR_move_pages                 NR(308)
#define NR_set_robust_list            NR(309)
#define NR_get_robust_list            NR(310)
#define NR_kexec_load                 NR(311)
#define NR_getcpu                     NR(312)
#define NR_epoll_pwait                NR(313)
#define NR_ioprio_set                 NR(314)
#define NR_ioprio_get                 NR(315)
#define NR_utimensat                  NR(316)
#define NR_signalfd                   NR(317)
#define NR_timerfd                    NR(318)
#define NR_eventfd                    NR(319)
#define NR_fallocate                  NR(320)
#define NR_timerfd_create             NR(321)
#define NR_timerfd_gettime            NR(322)
#define NR_timerfd_settime            NR(323)
#define NR_signalfd4                  NR(324)
#define NR_eventfd2                   NR(325)
#define NR_epoll_create1              NR(326)
#define NR_dup3                       NR(327)
#define NR_pipe2                      NR(328)
#define NR_inotify_init1              NR(329)
#define NR_preadv                     NR(330)
#define NR_pwritev                    NR(331)
#define NR_rt_tgsigqueueinfo          NR(332)
#define NR_perf_event_open            NR(333)
#define NR_accept4                    NR(334)
#define NR_recvmmsg                   NR(335)
#define NR_fanotify_init              NR(336)
#define NR_fanotify_mark              NR(337)
#define NR_prlimit64                  NR(338)
#define NR_name_to_handle_at          NR(339)
#define NR_open_by_handle_at          NR(340)
#define NR_clock_adjtime              NR(341)
#define NR_syncfs                     NR(342)
#define NR_sendmmsg                   NR(343)
#define NR_setns                      NR(344)
#define NR_process_vm_readv           NR(345)
#define NR_process_vm_writev          NR(346)
#define NR_kcmp                       NR(347)
#define NR_finit_module               NR(348)
#define NR_sched_setattr              NR(349)
#define NR_sched_getattr              NR(350)
#define NR_renameat2                  NR(351)
#define NR_seccomp                    NR(352)
#define NR_getrandom                  NR(353)
#define NR_memfd_create               NR(354)
#define NR_bpf                        NR(355)
#define NR_execveat                   NR(356)
#define NR_userfaultfd                NR(357)
#define NR_membarrier                 NR(358)
#define NR_mlock2                     NR(359)
#define NR_copy_file_range            NR(360)
#define NR_preadv2                    NR(361)
#define NR_pwritev2                   NR(362)

#endif
