#ifndef __BITS_SYSCALL_H__
#define __BITS_SYSCALL_H__

#define NR_read                       5000
#define NR_write                      5001
#define NR_open                       5002
#define NR_close                      5003
#define NR_stat                       5004
#define NR_fstat                      5005
#define NR_lstat                      5006
#define NR_poll                       5007
#define NR_lseek                      5008
#define NR_mmap                       5009
#define NR_mprotect                   5010
#define NR_munmap                     5011
#define NR_brk                        5012
#define NR_rt_sigaction               5013
#define NR_rt_sigprocmask             5014
#define NR_ioctl                      5015
#define NR_pread64                    5016
#define NR_pwrite64                   5017
#define NR_readv                      5018
#define NR_writev                     5019
#define NR_access                     5020
#define NR_pipe                       5021
#define NR__newselect                 5022
#define NR_sched_yield                5023
#define NR_mremap                     5024
#define NR_msync                      5025
#define NR_mincore                    5026
#define NR_madvise                    5027
#define NR_shmget                     5028
#define NR_shmat                      5029
#define NR_shmctl                     5030
#define NR_dup                        5031
#define NR_dup2                       5032
#define NR_pause                      5033
#define NR_nanosleep                  5034
#define NR_getitimer                  5035
#define NR_setitimer                  5036
#define NR_alarm                      5037
#define NR_getpid                     5038
#define NR_sendfile                   5039
#define NR_socket                     5040
#define NR_connect                    5041
#define NR_accept                     5042
#define NR_sendto                     5043
#define NR_recvfrom                   5044
#define NR_sendmsg                    5045
#define NR_recvmsg                    5046
#define NR_shutdown                   5047
#define NR_bind                       5048
#define NR_listen                     5049
#define NR_getsockname                5050
#define NR_getpeername                5051
#define NR_socketpair                 5052
#define NR_setsockopt                 5053
#define NR_getsockopt                 5054
#define NR_clone                      5055
#define NR_fork                       5056
#define NR_execve                     5057
#define NR_exit                       5058
#define NR_wait4                      5059
#define NR_kill                       5060
#define NR_uname                      5061
#define NR_semget                     5062
#define NR_semop                      5063
#define NR_semctl                     5064
#define NR_shmdt                      5065
#define NR_msgget                     5066
#define NR_msgsnd                     5067
#define NR_msgrcv                     5068
#define NR_msgctl                     5069
#define NR_fcntl                      5070
#define NR_flock                      5071
#define NR_fsync                      5072
#define NR_fdatasync                  5073
#define NR_truncate                   5074
#define NR_ftruncate                  5075
#define NR_getdents                   5076
#define NR_getcwd                     5077
#define NR_chdir                      5078
#define NR_fchdir                     5079
#define NR_rename                     5080
#define NR_mkdir                      5081
#define NR_rmdir                      5082
#define NR_creat                      5083
#define NR_link                       5084
#define NR_unlink                     5085
#define NR_symlink                    5086
#define NR_readlink                   5087
#define NR_chmod                      5088
#define NR_fchmod                     5089
#define NR_chown                      5090
#define NR_fchown                     5091
#define NR_lchown                     5092
#define NR_umask                      5093
#define NR_gettimeofday               5094
#define NR_getrlimit                  5095
#define NR_getrusage                  5096
#define NR_sysinfo                    5097
#define NR_times                      5098
#define NR_ptrace                     5099
#define NR_getuid                     5100
#define NR_syslog                     5101
#define NR_getgid                     5102
#define NR_setuid                     5103
#define NR_setgid                     5104
#define NR_geteuid                    5105
#define NR_getegid                    5106
#define NR_setpgid                    5107
#define NR_getppid                    5108
#define NR_getpgrp                    5109
#define NR_setsid                     5110
#define NR_setreuid                   5111
#define NR_setregid                   5112
#define NR_getgroups                  5113
#define NR_setgroups                  5114
#define NR_setresuid                  5115
#define NR_getresuid                  5116
#define NR_setresgid                  5117
#define NR_getresgid                  5118
#define NR_getpgid                    5119
#define NR_setfsuid                   5120
#define NR_setfsgid                   5121
#define NR_getsid                     5122
#define NR_capget                     5123
#define NR_capset                     5124
#define NR_rt_sigpending              5125
#define NR_rt_sigtimedwait            5126
#define NR_rt_sigqueueinfo            5127
#define NR_rt_sigsuspend              5128
#define NR_sigaltstack                5129
#define NR_utime                      5130
#define NR_mknod                      5131
#define NR_personality                5132
#define NR_ustat                      5133
#define NR_statfs                     5134
#define NR_fstatfs                    5135
#define NR_sysfs                      5136
#define NR_getpriority                5137
#define NR_setpriority                5138
#define NR_sched_setparam             5139
#define NR_sched_getparam             5140
#define NR_sched_setscheduler         5141
#define NR_sched_getscheduler         5142
#define NR_sched_get_priority_max     5143
#define NR_sched_get_priority_min     5144
#define NR_sched_rr_get_interval      5145
#define NR_mlock                      5146
#define NR_munlock                    5147
#define NR_mlockall                   5148
#define NR_munlockall                 5149
#define NR_vhangup                    5150
#define NR_pivot_root                 5151
#define NR__sysctl                    5152
#define NR_prctl                      5153
#define NR_adjtimex                   5154
#define NR_setrlimit                  5155
#define NR_chroot                     5156
#define NR_sync                       5157
#define NR_acct                       5158
#define NR_settimeofday               5159
#define NR_mount                      5160
#define NR_umount2                    5161
#define NR_swapon                     5162
#define NR_swapoff                    5163
#define NR_reboot                     5164
#define NR_sethostname                5165
#define NR_setdomainname              5166
#define NR_create_module              5167
#define NR_init_module                5168
#define NR_delete_module              5169
#define NR_get_kernel_syms            5170
#define NR_query_module               5171
#define NR_quotactl                   5172
#define NR_nfsservctl                 5173
#define NR_getpmsg                    5174
#define NR_putpmsg                    5175
#define NR_afs_syscall                5176
#define NR_reserved177                5177
#define NR_gettid                     5178
#define NR_readahead                  5179
#define NR_setxattr                   5180
#define NR_lsetxattr                  5181
#define NR_fsetxattr                  5182
#define NR_getxattr                   5183
#define NR_lgetxattr                  5184
#define NR_fgetxattr                  5185
#define NR_listxattr                  5186
#define NR_llistxattr                 5187
#define NR_flistxattr                 5188
#define NR_removexattr                5189
#define NR_lremovexattr               5190
#define NR_fremovexattr               5191
#define NR_tkill                      5192
#define NR_reserved193                5193
#define NR_futex                      5194
#define NR_sched_setaffinity          5195
#define NR_sched_getaffinity          5196
#define NR_cacheflush                 5197
#define NR_cachectl                   5198
#define NR_sysmips                    5199
#define NR_io_setup                   5200
#define NR_io_destroy                 5201
#define NR_io_getevents               5202
#define NR_io_submit                  5203
#define NR_io_cancel                  5204
#define NR_exit_group                 5205
#define NR_lookup_dcookie             5206
#define NR_epoll_create               5207
#define NR_epoll_ctl                  5208
#define NR_epoll_wait                 5209
#define NR_remap_file_pages           5210
#define NR_rt_sigreturn               5211
#define NR_set_tid_address            5212
#define NR_restart_syscall            5213
#define NR_semtimedop                 5214
#define NR_fadvise64                  5215
#define NR_timer_create               5216
#define NR_timer_settime              5217
#define NR_timer_gettime              5218
#define NR_timer_getoverrun           5219
#define NR_timer_delete               5220
#define NR_clock_settime              5221
#define NR_clock_gettime              5222
#define NR_clock_getres               5223
#define NR_clock_nanosleep            5224
#define NR_tgkill                     5225
#define NR_utimes                     5226
#define NR_mbind                      5227
#define NR_get_mempolicy              5228
#define NR_set_mempolicy              5229
#define NR_mq_open                    5230
#define NR_mq_unlink                  5231
#define NR_mq_timedsend               5232
#define NR_mq_timedreceive            5233
#define NR_mq_notify                  5234
#define NR_mq_getsetattr              5235
#define NR_vserver                    5236
#define NR_waitid                     5237
#define NR_add_key                    5239
#define NR_request_key                5240
#define NR_keyctl                     5241
#define NR_set_thread_area            5242
#define NR_inotify_init               5243
#define NR_inotify_add_watch          5244
#define NR_inotify_rm_watch           5245
#define NR_migrate_pages              5246
#define NR_openat                     5247
#define NR_mkdirat                    5248
#define NR_mknodat                    5249
#define NR_fchownat                   5250
#define NR_futimesat                  5251
#define NR_newfstatat                 5252
#define NR_unlinkat                   5253
#define NR_renameat                   5254
#define NR_linkat                     5255
#define NR_symlinkat                  5256
#define NR_readlinkat                 5257
#define NR_fchmodat                   5258
#define NR_faccessat                  5259
#define NR_pselect6                   5260
#define NR_ppoll                      5261
#define NR_unshare                    5262
#define NR_splice                     5263
#define NR_sync_file_range            5264
#define NR_tee                        5265
#define NR_vmsplice                   5266
#define NR_move_pages                 5267
#define NR_set_robust_list            5268
#define NR_get_robust_list            5269
#define NR_kexec_load                 5270
#define NR_getcpu                     5271
#define NR_epoll_pwait                5272
#define NR_ioprio_set                 5273
#define NR_ioprio_get                 5274
#define NR_utimensat                  5275
#define NR_signalfd                   5276
#define NR_timerfd                    5277
#define NR_eventfd                    5278
#define NR_fallocate                  5279
#define NR_timerfd_create             5280
#define NR_timerfd_gettime            5281
#define NR_timerfd_settime            5282
#define NR_signalfd4                  5283
#define NR_eventfd2                   5284
#define NR_epoll_create1              5285
#define NR_dup3                       5286
#define NR_pipe2                      5287
#define NR_inotify_init1              5288
#define NR_preadv                     5289
#define NR_pwritev                    5290
#define NR_rt_tgsigqueueinfo          5291
#define NR_perf_event_open            5292
#define NR_accept4                    5293
#define NR_recvmmsg                   5294
#define NR_fanotify_init              5295
#define NR_fanotify_mark              5296
#define NR_prlimit64                  5297
#define NR_name_to_handle_at          5298
#define NR_open_by_handle_at          5299
#define NR_clock_adjtime              5300
#define NR_syncfs                     5301
#define NR_sendmmsg                   5302
#define NR_setns                      5303
#define NR_process_vm_readv           5304
#define NR_process_vm_writev          5305
#define NR_kcmp                       5306
#define NR_finit_module               5307
#define NR_getdents64                 5308
#define NR_sched_setattr              5309
#define NR_sched_getattr              5310
#define NR_renameat2                  5311
#define NR_seccomp                    5312
#define NR_getrandom                  5313
#define NR_memfd_create               5314
#define NR_bpf                        5315
#define NR_execveat                   5316
#define NR_userfaultfd                5317
#define NR_membarrier                 5318
#define NR_mlock2                     5319
#define NR_copy_file_range            5320
#define NR_preadv2                    5321
#define NR_pwritev2                   5322
#define NR_pkey_mprotect              5323
#define NR_pkey_alloc                 5324
#define NR_pkey_free                  5325

#endif
