#include <bits/input/key.h>
#include <bits/input/btn.h>
#include <bits/input.h>
#include <util.h>

#include "inputs.h"

static const char* key[] = {
	[KEY_RESERVED] = "reserved",
	[KEY_ESC] = "Esc",
	[KEY_1] = "1",
	[KEY_2] = "2",
	[KEY_3] = "3",
	[KEY_4] = "4",
	[KEY_5] = "5",
	[KEY_6] = "6",
	[KEY_7] = "7",
	[KEY_8] = "8",
	[KEY_9] = "9",
	[KEY_0] = "0",
	[KEY_MINUS] = "minus",
	[KEY_EQUAL] = "equal",
	[KEY_BACKSPACE] = "Backspace",
	[KEY_TAB] = "Tab",
	[KEY_Q] = "Q",
	[KEY_W] = "W",
	[KEY_E] = "E",
	[KEY_R] = "R",
	[KEY_T] = "T",
	[KEY_Y] = "Y",
	[KEY_U] = "U",
	[KEY_I] = "I",
	[KEY_O] = "O",
	[KEY_P] = "P",
	[KEY_LEFTBRACE] = "left-brace",
	[KEY_RIGHTBRACE] = "right-brace",
	[KEY_ENTER] = "Enter",
	[KEY_LEFTCTRL] = "left-Ctrl",
	[KEY_A] = "A",
	[KEY_S] = "S",
	[KEY_D] = "D",
	[KEY_F] = "F",
	[KEY_G] = "G",
	[KEY_H] = "H",
	[KEY_J] = "J",
	[KEY_K] = "K",
	[KEY_L] = "L",
	[KEY_SEMICOLON] = "semicolon",
	[KEY_APOSTROPHE] = "apostrophe",
	[KEY_GRAVE] = "grave",
	[KEY_LEFTSHIFT] = "left-Shift",
	[KEY_BACKSLASH] = "backslash",
	[KEY_Z] = "Z",
	[KEY_X] = "X",
	[KEY_C] = "C",
	[KEY_V] = "V",
	[KEY_B] = "B",
	[KEY_N] = "N",
	[KEY_M] = "M",
	[KEY_COMMA] = "comma",
	[KEY_DOT] = "dot",
	[KEY_SLASH] = "slash",
	[KEY_RIGHTSHIFT] = "right-Shift",
	[KEY_KPASTERISK] = "KP-asterisk",
	[KEY_LEFTALT] = "left-Alt",
	[KEY_SPACE] = "Space",
	[KEY_CAPSLOCK] = "CapsLock",
	[KEY_F1] = "F1",
	[KEY_F2] = "F2",
	[KEY_F3] = "F3",
	[KEY_F4] = "F4",
	[KEY_F5] = "F5",
	[KEY_F6] = "F6",
	[KEY_F7] = "F7",
	[KEY_F8] = "F8",
	[KEY_F9] = "F9",
	[KEY_F10] = "F10",
	[KEY_NUMLOCK] = "NumLock",
	[KEY_SCROLLLOCK] = "ScrollLock",
	[KEY_KP7] = "KP7",
	[KEY_KP8] = "KP8",
	[KEY_KP9] = "KP9",
	[KEY_KPMINUS] = "KP-minus",
	[KEY_KP4] = "KP4",
	[KEY_KP5] = "KP5",
	[KEY_KP6] = "KP6",
	[KEY_KPPLUS] = "KP-plus",
	[KEY_KP1] = "KP1",
	[KEY_KP2] = "KP2",
	[KEY_KP3] = "KP3",
	[KEY_KP0] = "KP0",
	[KEY_KPDOT] = "KP-dot",
	[KEY_ZENKAKUHANKAKU] = "zenkaku-hankaku",
	[KEY_102ND] = "102nd",
	[KEY_F11] = "F11",
	[KEY_F12] = "F12",
	[KEY_RO] = "RO",
	[KEY_KATAKANA] = "katakana",
	[KEY_HIRAGANA] = "hiragana",
	[KEY_HENKAN] = "henkan",
	[KEY_KATAKANAHIRAGANA] = "katakana-hiragana",
	[KEY_MUHENKAN] = "muhenkan",
	[KEY_KPJPCOMMA] = "KP-jpcomma",
	[KEY_KPENTER] = "KP-Enter",
	[KEY_RIGHTCTRL] = "right-Ctrl",
	[KEY_KPSLASH] = "KP-slash",
	[KEY_SYSRQ] = "SysRq",
	[KEY_RIGHTALT] = "right-Alt",
	[KEY_LINEFEED] = "linefeed",
	[KEY_HOME] = "Home",
	[KEY_UP] = "Up",
	[KEY_PAGEUP] = "PageUp",
	[KEY_LEFT] = "Left",
	[KEY_RIGHT] = "Right",
	[KEY_END] = "End",
	[KEY_DOWN] = "Down",
	[KEY_PAGEDOWN] = "PageDown",
	[KEY_INSERT] = "Insert",
	[KEY_DELETE] = "Delete",
	[KEY_MACRO] = "macro",
	[KEY_MUTE] = "mute",
	[KEY_VOLUMEDOWN] = "volume-down",
	[KEY_VOLUMEUP] = "volume-up",
	[KEY_POWER] = "Power",
	[KEY_KPEQUAL] = "KP-equal",
	[KEY_KPPLUSMINUS] = "KP-plus-minus",
	[KEY_PAUSE] = "pause",
	[KEY_SCALE] = "scale",
	[KEY_KPCOMMA] = "KP-comma",
	[KEY_HANGEUL] = "hangeul",
	[KEY_HANJA] = "hanja",
	[KEY_YEN] = "yen",
	[KEY_LEFTMETA] = "left-Meta",
	[KEY_RIGHTMETA] = "right-Meta",
	[KEY_COMPOSE] = "Compose",
	[KEY_STOP] = "stop",
	[KEY_AGAIN] = "again",
	[KEY_PROPS] = "props",
	[KEY_UNDO] = "undo",
	[KEY_FRONT] = "front",
	[KEY_COPY] = "copy",
	[KEY_OPEN] = "open",
	[KEY_PASTE] = "paste",
	[KEY_FIND] = "find",
	[KEY_CUT] = "cut",
	[KEY_HELP] = "help",
	[KEY_MENU] = "menu",
	[KEY_CALC] = "calc",
	[KEY_SETUP] = "setup",
	[KEY_SLEEP] = "sleep",
	[KEY_WAKEUP] = "wakeup",
	[KEY_FILE] = "file",
	[KEY_SENDFILE] = "send-file",
	[KEY_DELETEFILE] = "delete-file",
	[KEY_XFER] = "xfer",
	[KEY_PROG1] = "prog1",
	[KEY_PROG2] = "prog2",
	[KEY_WWW] = "www",
	[KEY_MSDOS] = "msdos",
	[KEY_COFFEE] = "coffee",
	[KEY_ROTATE_DISPLAY] = "rotate-display",
	[KEY_CYCLEWINDOWS] = "cycle-windows",
	[KEY_MAIL] = "mail",
	[KEY_BOOKMARKS] = "bookmarks",
	[KEY_COMPUTER] = "computer",
	[KEY_BACK] = "back",
	[KEY_FORWARD] = "forward",
	[KEY_CLOSECD] = "close-cd",
	[KEY_EJECTCD] = "eject-cd",
	[KEY_EJECTCLOSECD] = "eject-close-cd",
	[KEY_NEXTSONG] = "next-song",
	[KEY_PLAYPAUSE] = "play-pause",
	[KEY_PREVIOUSSONG] = "previous-song",
	[KEY_STOPCD] = "stop-cd",
	[KEY_RECORD] = "record",
	[KEY_REWIND] = "rewind",
	[KEY_PHONE] = "phone",
	[KEY_ISO] = "ISO",
	[KEY_CONFIG] = "config",
	[KEY_HOMEPAGE] = "homepage",
	[KEY_REFRESH] = "refresh",
	[KEY_EXIT] = "exit",
	[KEY_MOVE] = "move",
	[KEY_EDIT] = "edit",
	[KEY_SCROLLUP] = "scroll-up",
	[KEY_SCROLLDOWN] = "scroll-down",
	[KEY_KPLEFTPAREN] = "KP-left-paren",
	[KEY_KPRIGHTPAREN] = "KP-right-paren",
	[KEY_NEW] = "new",
	[KEY_REDO] = "redo",
	[KEY_F13] = "F13",
	[KEY_F14] = "F14",
	[KEY_F15] = "F15",
	[KEY_F16] = "F16",
	[KEY_F17] = "F17",
	[KEY_F18] = "F18",
	[KEY_F19] = "F19",
	[KEY_F20] = "F20",
	[KEY_F21] = "F21",
	[KEY_F22] = "F22",
	[KEY_F23] = "F23",
	[KEY_F24] = "F24",
	[KEY_PLAYCD] = "play-cd",
	[KEY_PAUSECD] = "pause-cd",
	[KEY_PROG3] = "prog3",
	[KEY_PROG4] = "prog4",
	[KEY_DASHBOARD] = "dashboard",
	[KEY_SUSPEND] = "suspend",
	[KEY_CLOSE] = "close",
	[KEY_PLAY] = "play",
	[KEY_FASTFORWARD] = "fast-forward",
	[KEY_BASSBOOST] = "bass-boost",
	[KEY_PRINT] = "print",
	[KEY_HP] = "HP",
	[KEY_CAMERA] = "camera",
	[KEY_SOUND] = "sound",
	[KEY_QUESTION] = "question",
	[KEY_EMAIL] = "email",
	[KEY_CHAT] = "chat",
	[KEY_SEARCH] = "search",
	[KEY_CONNECT] = "connect",
	[KEY_FINANCE] = "finance",
	[KEY_SPORT] = "sport",
	[KEY_SHOP] = "shop",
	[KEY_ALTERASE] = "alterase",
	[KEY_CANCEL] = "cancel",
	[KEY_BRIGHTNESSDOWN] = "brightness-down",
	[KEY_BRIGHTNESSUP] = "brightness-up",
	[KEY_MEDIA] = "media",
	[KEY_SWITCHVIDEOMODE] = "switch-video-mode",
	[KEY_KBDILLUMTOGGLE] = "KBD-illum-toggle",
	[KEY_KBDILLUMDOWN] = "KBD-illum-down",
	[KEY_KBDILLUMUP] = "KBD-illum-up",
	[KEY_SEND] = "send",
	[KEY_REPLY] = "reply",
	[KEY_FORWARDMAIL] = "forward-mail",
	[KEY_SAVE] = "save",
	[KEY_DOCUMENTS] = "documents",
	[KEY_BATTERY] = "battery",
	[KEY_BLUETOOTH] = "bluetooth",
	[KEY_WLAN] = "wlan",
	[KEY_UWB] = "uwb",
	[KEY_UNKNOWN] = "unknown",
	[KEY_VIDEO_NEXT] = "Video-next",
	[KEY_VIDEO_PREV] = "Video-prev",
	[KEY_BRIGHTNESS_CYCLE] = "brightness-cycle",
	[KEY_BRIGHTNESS_AUTO] = "brightness-auto",
	[KEY_DISPLAY_OFF] = "display-off",
	[KEY_WWAN] = "wwan",
	[KEY_RFKILL] = "rfkill",
	[KEY_MICMUTE] = "mic-mute",

	[BTN_0] = "BTN-0",
	[BTN_1] = "BTN-1",
	[BTN_2] = "BTN-2",
	[BTN_3] = "BTN-3",
	[BTN_4] = "BTN-4",
	[BTN_5] = "BTN-5",
	[BTN_6] = "BTN-6",
	[BTN_7] = "BTN-7",
	[BTN_8] = "BTN-8",
	[BTN_9] = "BTN-9",

	[BTN_LEFT] = "BTN-left",
	[BTN_RIGHT] = "BTN-right",
	[BTN_MIDDLE] = "BTN-middle",
	[BTN_SIDE] = "BTN-side",
	[BTN_EXTRA] = "BTN-extra",
	[BTN_FORWARD] = "BTN-forward",
	[BTN_BACK] = "BTN-back",
	[BTN_TASK] = "BTN-task",

	[BTN_TRIGGER] = "BTN-trigger",
	[BTN_THUMB] = "BTN-thumb",
	[BTN_THUMB2] = "BTN-thumb2",
	[BTN_TOP] = "BTN-top",
	[BTN_TOP2] = "BTN-top2",
	[BTN_PINKIE] = "BTN-pinkie",
	[BTN_BASE] = "BTN-base",
	[BTN_BASE2] = "BTN-base2",
	[BTN_BASE3] = "BTN-base3",
	[BTN_BASE4] = "BTN-base4",
	[BTN_BASE5] = "BTN-base5",
	[BTN_BASE6] = "BTN-base6",
	[BTN_DEAD] = "BTN-dead",

	[BTN_SOUTH] = "BTN-south",
	[BTN_EAST] = "BTN-east",
	[BTN_NORTH] = "BTN-north",
	[BTN_WEST] = "btn-west",
	[BTN_Z] = "BTN-Z",
	[BTN_TL] = "BTN-TL",
	[BTN_TR] = "BTN-TR",
	[BTN_TL2] = "BTN-TL2",
	[BTN_TR2] = "BTN-TR2",
	[BTN_SELECT] = "BTN-select",
	[BTN_START] = "BTN-start",
	[BTN_MODE] = "BTN-mode",
	[BTN_THUMBL] = "BTN-thumb-L",
	[BTN_THUMBR] = "BTN-thumb-R",

	[BTN_TOOL_PEN] = "BTN-tool-pen",
	[BTN_TOOL_RUBBER] = "BTN-tool-rubber",
	[BTN_TOOL_BRUSH] = "BTN-tool-brush",
	[BTN_TOOL_PENCIL] = "BTN-tool-pencil",
	[BTN_TOOL_AIRBRUSH] = "BTN-tool-airbrush",
	[BTN_TOOL_FINGER] = "BTN-tool-finger",
	[BTN_TOOL_MOUSE] = "BTN-tool-mouse",
	[BTN_TOOL_LENS] = "BTN-tool-lens",
	[BTN_TOOL_QUINTTAP] = "BTN-tool-quint-tap",
	[BTN_TOUCH] = "BTN-touch",
	[BTN_STYLUS] = "BTN-stylus",
	[BTN_STYLUS2] = "BTN-stylus2",
	[BTN_TOOL_DOUBLETAP] = "BTN-tool-double-tap",
	[BTN_TOOL_TRIPLETAP] = "BTN-tool-triple-tap",
	[BTN_TOOL_QUADTAP] = "BTN-tool-quad-tap",

	[BTN_GEAR_DOWN] = "BTN-gear-down",
	[BTN_GEAR_UP] = "BTN-gear-up",

	[KEY_OK] = "Ok",
	[KEY_SELECT] = "select",
	[KEY_GOTO] = "goto",
	[KEY_CLEAR] = "clear",
	[KEY_POWER2] = "power2",
	[KEY_OPTION] = "option",
	[KEY_INFO] = "info",
	[KEY_TIME] = "time",
	[KEY_VENDOR] = "vendor",
	[KEY_ARCHIVE] = "archive",
	[KEY_PROGRAM] = "program",
	[KEY_CHANNEL] = "channel",
	[KEY_FAVORITES] = "favorites",
	[KEY_EPG] = "EPG",
	[KEY_PVR] = "PVR",
	[KEY_MHP] = "MHP",
	[KEY_LANGUAGE] = "language",
	[KEY_TITLE] = "title",
	[KEY_SUBTITLE] = "subtitle",
	[KEY_ANGLE] = "angle",
	[KEY_ZOOM] = "zoom",
	[KEY_MODE] = "mode",
	[KEY_KEYBOARD] = "keyboard",
	[KEY_SCREEN] = "screen",
	[KEY_PC] = "PC",
	[KEY_TV] = "TV",
	[KEY_TV2] = "TV2",
	[KEY_VCR] = "VCR",
	[KEY_VCR2] = "VCR2",
	[KEY_SAT] = "SAT",
	[KEY_SAT2] = "SAT2",
	[KEY_CD] = "CD",
	[KEY_TAPE] = "Tape",
	[KEY_RADIO] = "Radio",
	[KEY_TUNER] = "Tuner",
	[KEY_PLAYER] = "Player",
	[KEY_TEXT] = "Text",
	[KEY_DVD] = "DVD",
	[KEY_AUX] = "AUX",
	[KEY_MP3] = "MP3",
	[KEY_AUDIO] = "Audio",
	[KEY_VIDEO] = "Video",
	[KEY_DIRECTORY] = "Directory",
	[KEY_LIST] = "List",
	[KEY_MEMO] = "Memo",
	[KEY_CALENDAR] = "Calendar",
	[KEY_RED] = "Red",
	[KEY_GREEN] = "Green",
	[KEY_YELLOW] = "Yellow",
	[KEY_BLUE] = "Blue",
	[KEY_CHANNELUP] = "channel-up",
	[KEY_CHANNELDOWN] = "channel-down",
	[KEY_FIRST] = "first",
	[KEY_LAST] = "last",
	[KEY_AB] = "AB",
	[KEY_NEXT] = "next",
	[KEY_RESTART] = "restart",
	[KEY_SLOW] = "slow",
	[KEY_SHUFFLE] = "shuffle",
	[KEY_BREAK] = "break",
	[KEY_PREVIOUS] = "previous",
	[KEY_DIGITS] = "digits",
	[KEY_TEEN] = "teen",
	[KEY_TWEN] = "twen",
	[KEY_VIDEOPHONE] = "Videophone",
	[KEY_GAMES] = "Games",
	[KEY_ZOOMIN] = "zoom-in",
	[KEY_ZOOMOUT] = "zoom-out",
	[KEY_ZOOMRESET] = "zoom-reset",
	[KEY_WORDPROCESSOR] = "word-processor",
	[KEY_EDITOR] = "editor",
	[KEY_SPREADSHEET] = "spreadsheet",
	[KEY_GRAPHICSEDITOR] = "graphics-editor",
	[KEY_PRESENTATION] = "presentation",
	[KEY_DATABASE] = "database",
	[KEY_NEWS] = "news",
	[KEY_VOICEMAIL] = "voicemail",
	[KEY_ADDRESSBOOK] = "address-book",
	[KEY_MESSENGER] = "messenger",
	[KEY_DISPLAYTOGGLE] = "display-toggle",
	[KEY_SPELLCHECK] = "spellcheck",
	[KEY_LOGOFF] = "logoff",
	[KEY_DOLLAR] = "dollar",
	[KEY_EURO] = "euro",
	[KEY_FRAMEBACK] = "frame-back",
	[KEY_FRAMEFORWARD] = "frame-forward",
	[KEY_CONTEXT_MENU] = "context-menu",
	[KEY_MEDIA_REPEAT] = "media-repeat",
	[KEY_10CHANNELSUP] = "10-channels-up",
	[KEY_10CHANNELSDOWN] = "10-channels-down",
	[KEY_IMAGES] = "images",
	[KEY_DEL_EOL] = "Del-EOL",
	[KEY_DEL_EOS] = "Del-EOS",
	[KEY_INS_LINE] = "Ins-line",
	[KEY_DEL_LINE] = "Del-line",
	[KEY_FN] = "FN",
	[KEY_FN_ESC] = "FN_ESC",
	[KEY_FN_F1] = "FN_F1",
	[KEY_FN_F2] = "FN_F2",
	[KEY_FN_F3] = "FN_F3",
	[KEY_FN_F4] = "FN_F4",
	[KEY_FN_F5] = "FN_F5",
	[KEY_FN_F6] = "FN_F6",
	[KEY_FN_F7] = "FN_F7",
	[KEY_FN_F8] = "FN_F8",
	[KEY_FN_F9] = "FN_F9",
	[KEY_FN_F10] = "FN_F10",
	[KEY_FN_F11] = "FN_F11",
	[KEY_FN_F12] = "FN_F12",
	[KEY_FN_1] = "FN_1",
	[KEY_FN_2] = "FN_2",
	[KEY_FN_D] = "FN_D",
	[KEY_FN_E] = "FN_E",
	[KEY_FN_F] = "FN_F",
	[KEY_FN_S] = "FN_S",
	[KEY_FN_B] = "FN_B",
	[KEY_BRL_DOT1] = "BRL-dot1",
	[KEY_BRL_DOT2] = "BRL-dot2",
	[KEY_BRL_DOT3] = "BRL-dot3",
	[KEY_BRL_DOT4] = "BRL-dot4",
	[KEY_BRL_DOT5] = "BRL-dot5",
	[KEY_BRL_DOT6] = "BRL-dot6",
	[KEY_BRL_DOT7] = "BRL-dot7",
	[KEY_BRL_DOT8] = "BRL-dot8",
	[KEY_BRL_DOT9] = "BRL-dot9",
	[KEY_BRL_DOT10] = "BRL-dot10",
	[KEY_NUMERIC_0] = "numeric-0",
	[KEY_NUMERIC_1] = "numeric-1",
	[KEY_NUMERIC_2] = "numeric-2",
	[KEY_NUMERIC_3] = "numeric-3",
	[KEY_NUMERIC_4] = "numeric-4",
	[KEY_NUMERIC_5] = "numeric-5",
	[KEY_NUMERIC_6] = "numeric-6",
	[KEY_NUMERIC_7] = "numeric-7",
	[KEY_NUMERIC_8] = "numeric-8",
	[KEY_NUMERIC_9] = "numeric-9",
	[KEY_NUMERIC_STAR] = "numeric-STAR",
	[KEY_NUMERIC_POUND] = "numeric-POUND",
	[KEY_NUMERIC_A] = "numeric-A",
	[KEY_NUMERIC_B] = "numeric-B",
	[KEY_NUMERIC_C] = "numeric-C",
	[KEY_NUMERIC_D] = "numeric-D",
	[KEY_CAMERA_FOCUS] = "Camera-focus",
	[KEY_WPS_BUTTON] = "WPS-button",
	[KEY_TOUCHPAD_TOGGLE] = "touchpad-toggle",
	[KEY_TOUCHPAD_ON] = "touchpad-on",
	[KEY_TOUCHPAD_OFF] = "touchpad-off",
	[KEY_CAMERA_ZOOMIN] = "camera-zoom-in",
	[KEY_CAMERA_ZOOMOUT] = "camera-zoom-out",
	[KEY_CAMERA_UP] = "camera-up",
	[KEY_CAMERA_DOWN] = "camera-down",
	[KEY_CAMERA_LEFT] = "camera-left",
	[KEY_CAMERA_RIGHT] = "camera-right",
	[KEY_ATTENDANT_ON] = "attendant-on",
	[KEY_ATTENDANT_OFF] = "attendant-off",
	[KEY_ATTENDANT_TOGGLE] = "attendant-toggle",
	[KEY_LIGHTS_TOGGLE] = "lights-toggle",

	[BTN_DPAD_UP] = "dpad-up",
	[BTN_DPAD_DOWN] = "dpad-down",
	[BTN_DPAD_LEFT] = "dpad-left",
	[BTN_DPAD_RIGHT] = "dpad-right",

	[KEY_ALS_TOGGLE] = "ALS-toggle",
	[KEY_BUTTONCONFIG] = "button-config",
	[KEY_TASKMANAGER] = "task-manager",
	[KEY_JOURNAL] = "journal",
	[KEY_CONTROLPANEL] = "control-panel",
	[KEY_APPSELECT] = "app-select",
	[KEY_SCREENSAVER] = "screensaver",
	[KEY_VOICECOMMAND] = "voicecommand",
	[KEY_ASSISTANT] = "assistant",
	[KEY_BRIGHTNESS_MIN] = "brightness-min",
	[KEY_BRIGHTNESS_MAX] = "brightness-max",
	[KEY_KBDINPUTASSIST_PREV] = "kbd-input-assist-prev",
	[KEY_KBDINPUTASSIST_NEXT] = "kbd-input-assist-next",
	[KEY_KBDINPUTASSIST_PREVGROUP] = "kbd-input-assist_prev-group",
	[KEY_KBDINPUTASSIST_NEXTGROUP] = "kbd-input-assist_next-group",
	[KEY_KBDINPUTASSIST_ACCEPT] = "kbd-input-assist-accept",
	[KEY_KBDINPUTASSIST_CANCEL] = "kbd-input-assist-cancel",
	[KEY_RIGHT_UP] = "right-up",
	[KEY_RIGHT_DOWN] = "right-down",
	[KEY_LEFT_UP] = "left-up",
	[KEY_LEFT_DOWN] = "left-down",
	[KEY_ROOT_MENU] = "root-menu",
	[KEY_MEDIA_TOP_MENU] = "media-top-menu",
	[KEY_NUMERIC_11] = "numeric-11",
	[KEY_NUMERIC_12] = "numeric-12",
	[KEY_AUDIO_DESC] = "audio_desc",
	[KEY_3D_MODE] = "3D-mode",
	[KEY_NEXT_FAVORITE] = "next-favorite",
	[KEY_STOP_RECORD] = "stop-record",
	[KEY_PAUSE_RECORD] = "pause-record",
	[KEY_VOD] = "VOD",
	[KEY_UNMUTE] = "unmute",
	[KEY_FASTREVERSE] = "fast-reverse",
	[KEY_SLOWREVERSE] = "slow-reverse",
	[KEY_DATA] = "data",
	[KEY_ONSCREEN_KEYBOARD] = "onscreen-keyboard"
};

EVNAMES("KEY", key);
